## chezscheme 9.5.8%2Bdfsg

=== pkg/Makefile ===
# Makefile
# Copyright 1984-2017 Cisco Systems, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

m := $(shell find ../bin/* -type d | xargs basename)
version = 9.5.8
release = 1

DOTUSER = $(shell ls -ld . | sed -e 's/[^ ]* *[^ ]* *\([^ ]*\).*/\1/')
DOTGROUP = $(shell ls -ldg . | sed -e 's/[^ ]* *[^ ]* *\([^ ]*\).*/\1/')
BUILDROOT = $(m)$(version)
RELEASE = csv$(version)
TARBALL = $(RELEASE)-$(m).tar.gz
PKG = $(RELEASE)-$(m)-$(release).pkg

PKGCONTENT =\
 $(BUILDROOT)/Resources/en.lproj/Welcome.html\
 $(BUILDROOT)/Resources/en.lproj/License.txt\
 $(BUILDROOT)/Distribution\
 $(BUIDROOT)/Root/bin\
 $(BUILDROOT)/Root/lib\
 $(BUILDROOT)/Root/man

$(PKG): $(BUILDROOT)/$(PKG)
	sudo /usr/bin/productbuild\
          --resources $(BUILDROOT)/Resources\
          --distribution $(BUILDROOT)/Distribution\
          --package-path $(BUILDROOT)\
          $(PKG)
	sudo chown $(DOTUSER):$(DOTGROUP) $(PKG)
	sudo rm -rf $(RELEASE) $(BUILDROOT)

$(BUILDROOT)/$(PKG): $(PKGCONTENT)
	sudo /usr/bin/pkgbuild\
          --root $(BUILDROOT)/Root\
          --identifier chezscheme\
          --version $(version)\
          --install-location /\
          --ownership recommended\
          $(BUILDROOT)/$(PKG)

$(BUILDROOT)/Distribution: $(BUILDROOT)
	echo '<?xml version="1.0" encoding="utf-8" standalone="no"?>' > $(BUILDROOT)/Distribution
	echo '<installer-gui-script minSpecVersion="1">' >> $(BUILDROOT)/Distribution
	echo '    <pkg-ref id="chezscheme">' >> $(BUILDROOT)/Distribution
	echo '        <bundle-version/>' >> $(BUILDROOT)/Distribution
	echo '    </pkg-ref>' >> $(BUILDROOT)/Distribution
	echo '    <title>Chez Scheme</title>' >> $(BUILDROOT)/Distribution
	echo '    <welcome file="Welcome.html"/>' >> $(BUILDROOT)/Distribution
	echo '    <license file="License.txt"/>' >> $(BUILDROOT)/Distribution
	echo '    <options customize="never" rootVolumeOnly="true"/>' >> $(BUILDROOT)/Distribution
	echo '    <options customize="never" require-scripts="false"/>' >> $(BUILDROOT)/Distribution
	echo '    <choices-outline>' >> $(BUILDROOT)/Distribution
	echo '        <line choice="default">' >> $(BUILDROOT)/Distribution
	echo '            <line choice="chezscheme"/>' >> $(BUILDROOT)/Distribution
	echo '        </line>' >> $(BUILDROOT)/Distribution
	echo '    </choices-outline>' >> $(BUILDROOT)/Distribution
	echo '    <choice id="default"/>' >> $(BUILDROOT)/Distribution
	echo '    <choice id="chezscheme" visible="false">' >> $(BUILDROOT)/Distribution
	echo '        <pkg-ref id="chezscheme"/>' >> $(BUILDROOT)/Distribution
	echo '    </choice>' >> $(BUILDROOT)/Distribution
	echo '    <pkg-ref id="chezscheme" version="$(version)" onConclusion="none" installKBytes="1639">#$(PKG)</pkg-ref>' >> $(BUILDROOT)/Distribution
	echo '</installer-gui-script>' >> $(BUILDROOT)/Distribution
	chmod 644 $(BUILDROOT)/Distribution

$(BUILDROOT)/Resources/en.lproj/Welcome.html: $(BUILDROOT)/Resources/en.lproj
	echo '<html>' > $(BUILDROOT)/Resources/en.lproj/Welcome.html
	echo '<h3>Chez Scheme Version $(version)</h3>' >> $(BUILDROOT)/Resources/en.lproj/Welcome.html
	echo '<p>Copyright &copy; 2022 Cisco Systems, Inc.</p>' >> $(BUILDROOT)/Resources/en.lproj/Welcome.html
	echo '<p>Chez Scheme is a programming language and an implementation of that language, with supporting tools and documentation.</p>' >> $(BUILDROOT)/Resources/en.lproj/Welcome.html
	echo '</html>' >> $(BUILDROOT)/Resources/en.lproj/Welcome.html
	chmod 644 $(BUILDROOT)/Resources/en.lproj/Welcome.html

$(BUILDROOT)/Resources/en.lproj/License.txt: $(BUILDROOT)/Resources/en.lproj
	cat ../../NOTICE ../../LICENSE > $(BUILDROOT)/Resources/en.lproj/License.txt
	chmod 644 $(BUILDROOT)/Resources/en.lproj/License.txt

$(BUILDROOT)/Resources/en.lproj: $(BUILDROOT)/Resources
	install -d $(BUILDROOT)/Resources/en.lproj

$(BUILDROOT)/Resources: $(BUILDROOT)
	install -d $(BUILDROOT)/Resources

$(BUIDROOT)/Root/bin $(BUILDROOT)/Root/lib $(BUILDROOT)/Root/man: $(BUILDROOT)/Root $(RELEASE)
	( cd $(RELEASE); sudo make install InstallGroup=wheel TempRoot=../$(BUILDROOT)/Root )

$(BUILDROOT)/Root: $(BUILDROOT)
	install -d $(BUILDROOT)/Root

$(RELEASE): $(BUILDROOT) ../bintar/$(TARBALL)
	tar -xzf ../bintar/$(TARBALL)

$(BUILDROOT):
	install -d $(BUILDROOT)

clean:
	rm -rf $(PKG) $(BUILDROOT) $(RELEASE)

=== wininstall/Makefile ===
VERSION := 9.5.8
WIXEXTENSIONS := -ext WixUIExtension -ext WixBalExtension
export MSYS_NO_PATHCONV=1

ChezScheme.exe: x86/bundle.wixobj ChezScheme32.msi ChezScheme64.msi
	cmd.exe /c light.bat -nologo $(WIXEXTENSIONS) $< -out $@

ChezScheme32.msi: x86/product.wixobj x86/examples.wixobj x86/i3nt.wixobj x86/ti3nt.wixobj x86/vcredist.wixobj x86/ui.wixobj
	cmd.exe /c light.bat -nologo $(WIXEXTENSIONS) $^ -sice:ICE64 -sice:ICE03 -sice:ICE82 -sice:ICE61 -out "$@"

ChezScheme64.msi: x64/product.wixobj x64/a6nt.wixobj x64/examples.wixobj x64/ta6nt.wixobj x64/vcredist.wixobj x64/ui.wixobj
	cmd.exe /c light.bat -nologo $(WIXEXTENSIONS) $^ -sice:ICE64 -sice:ICE03 -sice:ICE82 -sice:ICE61 -out "$@"

x86/%.wixobj: %.wxs
	cmd.exe /c candle.bat -nologo -dVersion=$(VERSION) $(WIXEXTENSIONS) $< -out $@

x64/%.wixobj: %.wxs
	cmd.exe /c candle.bat -arch x64 -nologo -dVersion=$(VERSION) $(WIXEXTENSIONS) $< -out $@

vcredist.wxs: locate-vcredist.bat
	cmd.exe /c locate-vcredist.bat

.PHONY: workareas
workareas:
	cd ..; ./configure -m=a6nt; $(MAKE) -C a6nt
	cd ..; ./configure -m=i3nt; $(MAKE) -C i3nt
	cd ..; ./configure -m=ta6nt; $(MAKE) -C ta6nt
	cd ..; ./configure -m=ti3nt; $(MAKE) -C ti3nt

.PHONY: clean
clean:
	-rm -rf *.msi *.wixpdb x86/ x64/ vcredist.wxs *.wixobj *.exe

## chezscheme 9.5.8+dfsg

=== bintar/Makefile ===
# Makefile
# Copyright 1984-2017 Cisco Systems, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

version = 9.5.8
m := $(shell find ../bin/* -type d | xargs basename)

R = csv$(version)
TARBALL = $(R)-$(m).tar.gz

CONTENTS=\
  $(R)/LICENSE\
  $(R)/NOTICE\
  $(R)/scheme.1.in\
  $(R)/installsh\
  $(R)/Makefile\
  $(R)/examples\
  $(R)/boot\
  $(R)/bin

$(TARBALL): $(CONTENTS)
	( BROKEN=`find -L $R -type l` ; \
          if test -n "$$BROKEN" ; then \
             echo "Error: missing $(BROKEN)" ; \
             exit 1 ; \
          fi )
	tar -czhf $(TARBALL) $R
	rm -rf $(R) 

$(R)/LICENSE: $(R)
	( cd $(R) ; ln -s ../../../LICENSE . )

$(R)/NOTICE: $(R)
	( cd $(R) ; ln -s ../../../NOTICE . )

$(R)/scheme.1.in: $(R)
	( cd $(R) ; ln -s ../../scheme.1.in . )

$(R)/installsh: $(R)
	( cd $(R) ; ln -s ../../installsh . )

$(R)/Makefile: $(R)
	( cd $(R) ; ln -s ../../Mf-install Makefile )

$(R)/examples: $(R)
	( cd $(R) ; ln -s ../../examples . )

$(R)/boot: $(R)
	mkdir -p $(R)/boot/$(m)
	( cd $(R)/boot/$(m) ; ln -s ../../../../boot/$(m)/{scheme.h,petite.boot,scheme.boot,revision} . )
	case $(m) in \
          *nt) \
            ( cd $R/boot/$(m) ; ln -s ../../../../boot/$(m)/{csv958md.lib,csv958mt.lib,mainmd.obj,mainmt.obj,scheme.res} . ) \
            ;; \
          *) \
            ( cd $R/boot/$(m) ; ln -s ../../../../boot/$(m)/{main.o,kernel.o} . ) \
            ;; \
        esac

$(R)/bin: $(R)
	mkdir -p $(R)/bin/$(m)
	case $(m) in \
          *nt) \
            ( cd $R/bin/$(m) ; ln -s ../../../../bin/$(m)/{scheme.exe,csv958.dll,csv958.lib,vcruntime140.lib} . ) \
            ;; \
          *) \
            ( cd $R/bin/$(m) ; ln -s ../../../../bin/$(m)/scheme . ) \
            ;; \
        esac

$(R):
	mkdir $(R)

clean:
	rm -rf $(R) $(TARBALL)

=== examples/Makefile ===
# Unix make file to compile the examples.
# Compilation is not necessary since the examples may be loaded from
# source, but this gives an example of how to use make for Scheme.
# * To compile files not already compiled, type "make".  Only those
#   files in the object list below and not yet compiled will be compiled.
# * To compile all files, type "make all".  Only those files in the object
#   list below will be compiled.
# * To compile one file, say "fumble.ss", type "make fumble.so".  The
#   file need not be in the object list below.
# * To remove the object files, type "make clean".
# * To print the examples, type "make print".

src = def.ss edit.ss fact.ss fatfib.ss fft.ss fib.ss freq.ss interpret.ss\
 m4.ss macro.ss matrix.ss object.ss power.ss queue.ss rabbit.ss rsa.ss\
 scons.ss setof.ss socket.ss unify.ss compat.ss ez-grammar-test.ss
obj = ${src:%.ss=%.so}

Scheme = ../bin/scheme -q

.SUFFIXES:
.SUFFIXES: .ss .so
.ss.so: ; echo '(time (compile-file "$*"))' | ${Scheme}

needed:	${obj}

all: ; echo "(time (for-each compile-file (map symbol->string '(${src}))))" | ${Scheme}

clean: ; rm -f $(obj) expr.md

=== rpm/Makefile ===
# Makefile
# Copyright 1984-2017 Cisco Systems, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

version = 9.5.8
release = 1
m := $(shell find ../bin/* -type d | xargs basename)
arch := $(shell if test "$(m)" == "i3le" ; then echo i686 ; elif test "$(m)" == "a6le" ; then echo x86_64 ; else echo UNKNOWN ; fi)
DOTUSER := $(shell ls -ld . | sed -e 's/[^ ]* *[^ ]* *\([^ ]*\).*/\1/')
DOTGROUP := $(shell ls -ldg . | sed -e 's/[^ ]* *[^ ]* *\([^ ]*\).*/\1/')
TMP := $(shell pwd)/tmp
SPEC = $(TMP)/ChezScheme-$(version)-$(arch)-$(release).spec
RELEASE = csv$(version)
TARBALL = $(RELEASE)-$(m).tar.gz
RPM = ChezScheme-$(version)-$(release).$(arch).rpm


$(RPM): $(TMP)/$(RPM)
	sudo install -m 644 -o $(DOTUSER) -g $(DOTGROUP) $(TMP)/${RPM} .

$(TMP)/$(RPM): $(SPEC) $(TMP)/$(TARBALL)
	sudo setarch $(arch) rpmbuild\
          --target $(arch)\
          --define "_topdir $(TMP)" \
          --define "_srcrpmdir $(TMP)" \
          --define "_rpmdir $(TMP)" \
          --define "_sourcedir $(TMP)" \
          --define "_builddir $(TMP)" \
          --define "_rpmfilename %{NAME}-%{VERSION}-%{RELEASE}.%{ARCH}.rpm" \
          --quiet -ba $(SPEC)

$(SPEC): $(TMP)
	echo 'Summary: Chez Scheme: A high-performance version of Scheme' > $(SPEC)
	echo 'Name: ChezScheme' >> $(SPEC)
	echo 'Version: $(version)' >> $(SPEC)
	echo 'Release: $(release)' >> $(SPEC)
	echo 'Provides: ChezScheme-runtime-{VERSION}' >> $(SPEC)
	echo 'License: Apache 2.0' >> $(SPEC)
	echo 'URL: http://github.com/cisco/chezscheme' >> $(SPEC)
	echo 'Group: Development/Languages' >> $(SPEC)
	echo 'Source0: $(TARBALL)' >> $(SPEC)
	echo 'BuildRoot: %{_tmppath}/%{name}' >> $(SPEC)
	echo '%description' >> $(SPEC)
	echo 'Chez Scheme is a programming language and an implementation of that language,' >> $(SPEC)
	echo 'with supporting tools and documentation.' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '%prep' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '%setup -T -b 0 -n $(RELEASE)' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '#%build' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '%install' >> $(SPEC)
	echo 'make install TempRoot=%{buildroot}' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '%files' >> $(SPEC)
	echo '#%doc NOTICE' >> $(SPEC)
	echo '#%doc LICENSE' >> $(SPEC)
	echo '/usr/lib/$(RELEASE)' >> $(SPEC)
	echo '/usr/bin/petite' >> $(SPEC)
	echo '/usr/bin/scheme' >> $(SPEC)
	echo '/usr/bin/scheme-script' >> $(SPEC)
	echo '/usr/share/man/man1/petite.1.gz' >> $(SPEC)
	echo '/usr/share/man/man1/scheme.1.gz' >> $(SPEC)

$(TMP)/$(TARBALL): $(TMP) ../bintar/$(TARBALL)
	cp ../bintar/$(TARBALL) $(TMP)

$(TMP):
	mkdir $(TMP)

clean:
	rm -rf $(TMP) $(RPM)

=== csug/math/Makefile ===
include mathfiles

density=-r90x90

.SUFFIXES:
.SUFFIXES: .tex .gif

# translate ps file to ppm, crop to minimum background, and translate ppm
# to gif with white (background) transparent
#
.tex.gif:
	echo | latex $* &&\
          dvips -f < $*.dvi |\
          gs -q -dNOPAUSE -dSAFER -sDEVICE=ppmraw -sOutputFile=-\
          ${density} - |\
          pnmcrop |\
          ppmtogif -transparent white > $*.gif
	rm -f $*.dvi $*.log $*.aux
	test -f $*.gif && chmod 644 $*.gif

all: ${gifs}

${gifs}: mathmacros

clean: ; rm -f *.gif Make.out

=== release_notes/gifs/Makefile ===
gifs = ghostRightarrow.gif

density=-r90x90

.SUFFIXES:
.SUFFIXES: .tex .gif

# translate ps file to ppm, crop to minimum background, and translate ppm
# to gif with white (background) transparent
#
.tex.gif:
	echo | latex $* &&\
          dvips -f < $*.dvi |\
          gs -q -dNOPAUSE -dSAFER -sDEVICE=ppmraw -sOutputFile=-\
          ${density} - |\
          pnmcrop |\
          ppmtogif -transparent white > $*.gif
	rm -f $*.dvi $*.log *.aux
	test -f $*.gif && chmod 644 $*.gif

all: ${gifs}

# make ghostRightarrow.gif a completely transparent version of Rightarrow.ps
#
# translate ps to gif as above but w/o making white transparent, map black
# to white, convert to ppm, and convert back to gif with white transparent
#
# could skip intermediate conversion to gif if we could map black to white
# with some ppm tool
#
# it seems like should be able to replace last three steps with
#    giftrans -g '#000000=#ffffff' -t '#ffffff'
# or at least
#    giftrans -g '#000000=#ffffff' | giftrans -t '#ffffff'
# but giftrans changes only the first white color it sees, not all
#
ghostRightarrow.gif: Rightarrow.tex
	echo | latex Rightarrow &&\
          dvips -f < Rightarrow.dvi |\
          gs -q -dNOPAUSE -dSAFER -sDEVICE=ppmraw -sOutputFile=-\
          ${density} - |\
          pnmcrop |\
          ppmtogif |\
          giftrans -g '#000000=#ffffff' |\
          giftopnm |\
          ppmtogif -transparent white > $*.gif
	rm -f Rightarrow.dvi Rightarrow.log Rightarrow.aux
	test -f $*.gif && chmod 644 $*.gif

clean: ; rm -f *.gif Make.out

=== debian/changelog ===
chezscheme (9.5.8+dfsg-1) unstable; urgency=low

  * New upstream release
  * debian/patches: Refresh patches
  * Drop patches applied upstream:
    - 0005-continuation-repair-for-return-arity-error.patch
    - 0006-make-arm32-return-address-encoding-montonic-w.r.t.-o.patch
    - 0007-Add-arm32le-boot-files-missing-in-the-release-tarbal.patch
  * Update the lintian overrides to handle a syntax change
  * debian/copyright: Update copyright years
  * Update to Standards-Version 4.6.1 (no changes)

 -- Göran Weinholt <weinholt@debian.org>  Sat, 01 Oct 2022 20:58:19 +0200

=== debian/control ===
Source: chezscheme
Section: lisp
Priority: optional
Maintainer: Göran Weinholt <weinholt@debian.org>
Uploaders: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper (>= 10), dh-exec
Build-Depends-Arch: zlib1g-dev | libz-dev,
       zlib1g-dev:native | libz-dev:native,
       liblz4-dev,
       liblz4-dev:native,
       libncurses5-dev | libncurses-dev | ncurses-dev,
       libncurses5-dev:native | libncurses-dev:native | ncurses-dev:native,
       uuid-dev,
       uuid-dev:native,
       libx11-dev,
       r6rs-nanopass-dev
Build-Depends-Indep: stex <!nodoc>
Standards-Version: 4.6.1
Homepage: https://cisco.github.io/ChezScheme/
Vcs-Git: https://salsa.debian.org/scheme-team/chezscheme.git
Vcs-Browser: https://salsa.debian.org/scheme-team/chezscheme

Package: chezscheme
Architecture: i386 amd64 armhf
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: ikarus (<< 0.0.3+bzr.2010.01.26-5)
Suggests: chezscheme-doc
Description: Reliable, high performance Scheme compiler
 Chez Scheme is both a programming language and an implementation of
 that language, with supporting tools and documentation.
 .
 As a superset of the language described in the Revised^6 Report on
 the Algorithmic Language Scheme (R6RS), Chez Scheme supports all
 standard features of Scheme, including first-class procedures, proper
 treatment of tail calls, continuations, user-defined records,
 libraries, exceptions, and hygienic macro expansion.
 .
 Chez Scheme also includes extensive support for interfacing with C
 and other languages, support for multiple threads possibly running on
 multiple cores, non-blocking I/O, and many other features.

Package: chezscheme-dev
Section: devel
Architecture: i386 amd64 armhf
Multi-Arch: same
Depends: chezscheme (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Reliable, high performance Scheme compiler (C development files)
 Chez Scheme is both a programming language and an implementation of
 that language, with supporting tools and documentation.
 .
 This package contains the runtime kernel and C headers.

Package: chezscheme-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Build-Profiles: <!nodoc>
Description: Reliable, high performance Scheme compiler (documentation)
 Chez Scheme is both a programming language and an implementation of
 that language, with supporting tools and documentation.
 .
 This package contains the documentation.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/chezscheme-$1\.tar\.gz/,dversionmangle=auto,repacksuffix=+dfsg \
  https://github.com/cisco/ChezScheme/tags .*/v?(\d\S+)\.tar\.gz

## chezscheme 10.0.0+dfsg

=== examples/Makefile ===
--- 
+++ 
@@ -15,14 +15,15 @@
  scons.ss setof.ss socket.ss unify.ss compat.ss ez-grammar-test.ss
 obj = ${src:%.ss=%.so}
 
-Scheme = ../bin/scheme -q
+Scheme = ../bin/scheme
+SchemeArg = -q
 
 .SUFFIXES:
 .SUFFIXES: .ss .so
-.ss.so: ; echo '(time (compile-file "$*"))' | ${Scheme}
+.ss.so: ; echo '(time (compile-file "$*"))' | "${Scheme}" ${SchemeArg}
 
 needed:	${obj}
 
-all: ; echo "(time (for-each compile-file (map symbol->string '(${src}))))" | ${Scheme}
+all: ; echo "(time (for-each compile-file (map symbol->string '(${src}))))" | "${Scheme}" ${SchemeArg}
 
 clean: ; rm -f $(obj) expr.md

=== rpm/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-version = 9.5.8
+version = 10.0.0
 release = 1
 m := $(shell find ../bin/* -type d | xargs basename)
 arch := $(shell if test "$(m)" == "i3le" ; then echo i686 ; elif test "$(m)" == "a6le" ; then echo x86_64 ; else echo UNKNOWN ; fi)

=== unicode/Makefile ===
Scheme=../bin/zuo .. run

doit:
	$(MAKE) update
	$(MAKE) unicode-char-cases.ss unicode-charinfo.ss

update:
	./get-UNIDATA

unicode-char-cases.ss: extract-char-cases.ss extract-common.ss unicode-data.ss
	echo | $(Scheme) -q extract-char-cases.ss

unicode-charinfo.ss: extract-info.ss extract-common.ss unicode-data.ss
	echo | $(Scheme) -q extract-info.ss

unicode-char-cases.ss: \
 UNIDATA/CompositionExclusions.txt\
 UNIDATA/UnicodeData.txt\
 UNIDATA/CaseFolding.txt\
 UNIDATA/SpecialCasing.txt\
 UNIDATA/GraphemeBreakProperty.txt

unicode-charinfo.ss: \
 UNIDATA/UnicodeData.txt\
 UNIDATA/WordBreakProperty.txt\
 UNIDATA/PropList.txt\
 UNIDATA/emoji-data.txt

=== wininstall/Makefile ===
VERSION := 10.0.0
WIXEXTENSIONS := -ext WixUIExtension -ext WixBalExtension
export MSYS_NO_PATHCONV=1

ChezScheme.exe: x86/bundle.wixobj ChezScheme32.msi ChezScheme64.msi
	cmd.exe /c "light.bat -nologo $(WIXEXTENSIONS) $< -out $@"

ChezScheme32.msi: x86/product.wixobj x86/examples.wixobj x86/i3nt.wixobj x86/ti3nt.wixobj x86/ui.wixobj
	cmd.exe /c "light.bat -nologo $(WIXEXTENSIONS) $^ -sice:ICE64 -sice:ICE03 -sice:ICE82 -sice:ICE61 -out $@"

ChezScheme64.msi: x64/product.wixobj x64/a6nt.wixobj x64/examples.wixobj x64/ta6nt.wixobj x64/ui.wixobj
	cmd.exe /c "light.bat -nologo $(WIXEXTENSIONS) $^ -sice:ICE64 -sice:ICE03 -sice:ICE82 -sice:ICE61 -out $@"

x86/%.wixobj: %.wxs
	cmd.exe /c "candle.bat -nologo -dVersion=$(VERSION) $(WIXEXTENSIONS) $< -out $@"

x64/%.wixobj: %.wxs
	cmd.exe /c "candle.bat -arch x64 -nologo -dVersion=$(VERSION) $(WIXEXTENSIONS) $< -out $@"

# After building a6nt, use it to create boot files for the
# other machine types, since that's faster than going through
# pb every time
.PHONY: workareas
workareas:
	cd ..; cmd.exe /c "build.bat a6nt"
	cd ..; ./zuo.exe . bootquick i3nt
	cd ..; ./zuo.exe . bootquick ta6nt
	cd ..; ./zuo.exe . bootquick ti3nt
	cd ..; cmd.exe /c "build.bat i3nt"
	cd ..; cmd.exe /c "build.bat ta6nt"
	cd ..; cmd.exe /c "build.bat ti3nt"

.PHONY: clean
clean:
	-rm -rf *.msi *.wixpdb x86/ x64/ *.wixobj *.exe

=== debian/changelog ===
chezscheme (10.0.0+dfsg-5) unstable; urgency=medium

  * Upload to unstable.

 -- Gwen Weinholt <weinholt@debian.org>  Sun, 25 Aug 2024 15:49:23 +0200

chezscheme (10.0.0+dfsg-4) experimental; urgency=medium

  * debian/control: Build-Depend on the native version of zuo
  * debian/patches: Fix builds on s390x, m68k and hppa

 -- Gwen Weinholt <weinholt@debian.org>  Mon, 08 Jul 2024 21:10:31 +0200

chezscheme (10.0.0+dfsg-3) experimental; urgency=medium

  * debian/rules: Be more careful about arguments to rm
  * debian/patches: Auto-detect endianness and word size on Linux

 -- Gwen Weinholt <weinholt@debian.org>  Thu, 04 Jul 2024 00:42:11 +0200

chezscheme (10.0.0+dfsg-2) experimental; urgency=medium

  * Use bytecode for armel; tarm32le does not work
  * debian/rules: Always build with an explicit machine type
  * Move Build-Depends-Arch into Build-Depends to fix indep builds
  * debian/patches: Fix wcwidth() definition for GNU Hurd in expeditor

 -- Gwen Weinholt <weinholt@debian.org>  Mon, 01 Jul 2024 00:48:30 +0200

chezscheme (10.0.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * debian/copyright: Exclude zuo/ from the upstream tarball
  * debian: New maintainer name
  * debian/control: Add new build-depends zuo
  * debian/control: Set Architecture=any; Chez is portable now
  * debian/README.source: remove obsolete instructions
  * debian/control: Remove obsolete libncurses5-dev build-dep
  * debian/patches: Allow zuo from the system to be used
  * debian/patches: Fix whatis entry in scheme.1.in
  * debian/patches: Skip git submodule checks with --as-is
  * Rebase patches
  * debian: Reworked for extensive upstream changes in 10.0.0

 -- Gwen Weinholt <weinholt@debian.org>  Sun, 23 Jun 2024 19:54:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: chezscheme
 Section: lisp
 Priority: optional
-Maintainer: Göran Weinholt <weinholt@debian.org>
+Maintainer: Gwen Weinholt <weinholt@debian.org>
 Uploaders: Barak A. Pearlmutter <bap@debian.org>
-Build-Depends: debhelper (>= 10), dh-exec
-Build-Depends-Arch: zlib1g-dev | libz-dev,
+Build-Depends: debhelper (>= 10), dh-exec,
+       zuo:native,
+       zlib1g-dev | libz-dev,
        zlib1g-dev:native | libz-dev:native,
        liblz4-dev,
        liblz4-dev:native,
-       libncurses5-dev | libncurses-dev | ncurses-dev,
-       libncurses5-dev:native | libncurses-dev:native | ncurses-dev:native,
+       libncurses-dev,
+       libncurses-dev:native,
        uuid-dev,
        uuid-dev:native,
        libx11-dev,
@@ -21,7 +22,7 @@
 Vcs-Browser: https://salsa.debian.org/scheme-team/chezscheme
 
 Package: chezscheme
-Architecture: i386 amd64 armhf
+Architecture: any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: ikarus (<< 0.0.3+bzr.2010.01.26-5)
@@ -42,7 +43,7 @@
 
 Package: chezscheme-dev
 Section: devel
-Architecture: i386 amd64 armhf
+Architecture: any
 Multi-Arch: same
 Depends: chezscheme (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: Reliable, high performance Scheme compiler (C development files)

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

export CHEZ_VERSION = $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -e 's/[+~].*$$//')
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DOPACKAGES = $(shell dh_listpackages)

# Translate the host architecture (the arch we're building for) to
# terms the build system understands.
ifeq ($(DEB_HOST_GNU_TYPE), x86_64-linux-gnu)
    export HOST_MACHINE_TYPE = ta6le
else ifeq ($(DEB_HOST_GNU_TYPE), i386-linux-gnu)
    export HOST_MACHINE_TYPE = ti3le
else ifeq ($(DEB_HOST_GNU_TYPE), i686-linux-gnu)
    export HOST_MACHINE_TYPE = ti3le
else ifeq ($(DEB_HOST_GNU_TYPE), aarch64-linux-gnu)
    export HOST_MACHINE_TYPE = tarm64le
else ifeq ($(DEB_HOST_GNU_TYPE), arm-linux-gnueabihf)
    export HOST_MACHINE_TYPE = tarm32le
else ifeq ($(DEB_HOST_GNU_TYPE), riscv64-linux-gnu)
    export HOST_MACHINE_TYPE = trv64le
else ifeq ($(DEB_HOST_GNU_TYPE), loongarch64-linux-gnu)
    export HOST_MACHINE_TYPE = tla64le
else ifeq ($(DEB_HOST_GNU_TYPE), powerpc-linux-gnu)
    export HOST_MACHINE_TYPE = tppc32le
else ifeq ($(DEB_HOST_GNU_TYPE), i686-gnu)
    export HOST_MACHINE_TYPE = ti3gnu
else
    # Example bytecode machine type: tpb64l
    export HOST_MACHINE_TYPE = tpb$(DEB_HOST_ARCH_BITS)$(shell echo $(DEB_HOST_ARCH_ENDIAN) | cut -c1)
    $(warning Cannot yet build for $(DEB_HOST_GNU_TYPE), building for $(HOST_MACHINE_TYPE))
    USE_BYTECODE = 1
endif
ifeq ($(origin CC),default)
CC := $(DEB_HOST_GNU_TYPE)-gcc
LD := $(DEB_HOST_GNU_TYPE)-ld
endif

# We want the system-provided versions of these
INSTALLED_CHEZ=/usr/bin/chezscheme
export STEXLIB=/usr/share/stex
export ZUO=/usr/bin/zuo

LIBDIR=usr/lib/csv$(CHEZ_VERSION)/$(HOST_MACHINE_TYPE)

%:
	dh $@

override_dh_auto_configure:
ifeq ($(USE_BYTECODE),1)
	CC=$(CC) ./configure --as-is --pbarch --threads --installschemename=chezscheme --installprefix=$(shell pwd)/debian/tmp/usr ZLIB=-lz LZ4=-llz4
else
	CC=$(CC) ./configure --as-is -m=$(HOST_MACHINE_TYPE) --installschemename=chezscheme --installprefix=$(shell pwd)/debian/tmp/usr ZLIB=-lz LZ4=-llz4
endif
	ln -s /usr/share/r6rs nanopass

override_dh_auto_test:
ifeq (fullcheck,$(filter fullcheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
endif

override_dh_auto_build:
	make -j`nproc` ZUO=/usr/bin/zuo
ifneq (,$(filter chezscheme-doc,$(DOPACKAGES)))
	$(ZUO) main.zuo docs
endif

override_dh_auto_install:
	make install TempRoot=$(shell pwd)/debian/tmp
ifneq (,$(filter chezscheme-doc,$(DOPACKAGES)))
	$(ZUO) main.zuo install-docs
endif

ifneq (,$(filter chezscheme,$(DOPACKAGES)))
override_dh_link:
	dh_link $(LIBDIR)/scheme.boot $(LIBDIR)/chezscheme.boot \
	        $(LIBDIR)/scheme.boot $(LIBDIR)/scheme-script.boot \
	        /usr/share/man/man1/chezscheme.1.gz \
	        /usr/share/man/man1/petite.1.gz \
	        /usr/share/man/man1/chezscheme.1.gz \
	        /usr/share/man/man1/scheme-script-chez.1.gz
endif

override_dh_auto_clean:
	rm -f Makefile main.zuo
	rm -f nanopass
	rm -rf ./build ./pb ./xc-* "./$(HOST_MACHINE_TYPE)"
	rm -rf "./boot/$(HOST_MACHINE_TYPE)/"
	if test -f csug/Makefile; then make -C csug clean STEXLIB=$(STEXLIB) ; fi
	rm -f csug/primdata.ss csug/Makefile
	rm -rf csug/csug.pdf csug/math csug/gifs csug/*.html
	rm -f release_notes/Makefile release_notes/macros.tex release_notes/release_notes.log release_notes/release_notes.tex release_notes/release_notes.htoc
	rm -rf release_notes/gifs/ release_notes/math/ release_notes/release_notes.aux release_notes/release_notes.firstrun release_notes/release_notes.haux release_notes/release_notes.hfirstrun release_notes/release_notes.hsecondrun release_notes/release_notes.hthirdrun release_notes/release_notes.html release_notes/release_notes.mathrun release_notes/release_notes.pdf release_notes/release_notes.secondrun release_notes/release_notes.thirdrun
	dh_auto_clean

override_dh_installdocs:
	dh_installdocs -A NOTICE
